# -*- coding: utf-8 -*-

from recc_database.variables.database import (
    INFO_KEY_RECC_DB_VERSION,
    TABLE_INFO,
    TABLE_USER,
    VIEW_INFO_DB_VERSION,
    VIEW_USER_ADMIN,
    VIEW_USER_ADMIN_COUNT,
)

CREATE_VIEW_INFO_DB_VERSION = f"""
CREATE OR REPLACE VIEW {VIEW_INFO_DB_VERSION}
AS SELECT
    value AS version
FROM
    {TABLE_INFO}
WHERE
    key='{INFO_KEY_RECC_DB_VERSION}';
"""

CREATE_VIEW_USER_ADMIN = f"""
CREATE OR REPLACE VIEW {VIEW_USER_ADMIN}
AS SELECT
    uid, username, email
FROM
    {TABLE_USER}
WHERE
    admin=TRUE;
"""

CREATE_VIEW_USER_ADMIN_COUNT = f"""
CREATE OR REPLACE VIEW {VIEW_USER_ADMIN_COUNT}
AS SELECT
    count(uid) AS count
FROM
    {TABLE_USER}
WHERE
    admin=TRUE;
"""

CREATE_VIEWS = (
    CREATE_VIEW_INFO_DB_VERSION,
    CREATE_VIEW_USER_ADMIN,
    CREATE_VIEW_USER_ADMIN_COUNT,
)

DROP_VIEW_INFO_VERSION = f"DROP VIEW IF EXISTS {VIEW_INFO_DB_VERSION};"
DROP_VIEW_USER_ADMIN = f"DROP VIEW IF EXISTS {VIEW_USER_ADMIN};"
DROP_VIEW_USER_ADMIN_COUNT = f"DROP VIEW IF EXISTS {VIEW_USER_ADMIN_COUNT};"

DROP_VIEWS = (
    DROP_VIEW_INFO_VERSION,
    DROP_VIEW_USER_ADMIN,
    DROP_VIEW_USER_ADMIN_COUNT,
)
